package com.sun.xml.internal.ws.client.dispatch;

import com.sun.xml.internal.ws.api.message.Messages;
import com.sun.xml.internal.ws.message.source.PayloadSourceMessage;
import com.sun.xml.internal.ws.api.message.Message;
import javax.xml.ws.WebServiceException;
import com.sun.xml.internal.ws.api.message.Packet;
import com.sun.xml.internal.ws.api.client.WSPortInfo;
import com.sun.xml.internal.ws.api.addressing.WSEndpointReference;
import com.sun.xml.internal.ws.binding.BindingImpl;
import com.sun.xml.internal.ws.api.pipe.Tube;
import com.sun.xml.internal.ws.client.WSServiceDelegate;
import javax.xml.ws.Service;
import javax.xml.namespace.QName;
import javax.xml.transform.Source;

final class SOAPSourceDispatch extends DispatchImpl<Source>
{
    @Deprecated
    public SOAPSourceDispatch(QName port, Service.Mode mode, WSServiceDelegate owner, Tube pipe, BindingImpl binding, WSEndpointReference epr) {
        super(port, mode, owner, pipe, binding, epr);
        assert !DispatchImpl.isXMLHttp(binding);
        return;
    }
    
    public SOAPSourceDispatch(WSPortInfo portInfo, Service.Mode mode, BindingImpl binding, WSEndpointReference epr) {
        super(portInfo, mode, binding, epr);
        assert !DispatchImpl.isXMLHttp(binding);
        return;
    }
    
    @Override
    Source toReturnValue(Packet response) {
        Message msg = response.getMessage();
        switch (this.mode) {
            case PAYLOAD: {
                return msg.readPayloadAsSource();
            }
            case MESSAGE: {
                return msg.readEnvelopeAsSource();
            }
            default: {
                throw new WebServiceException("Unrecognized dispatch mode");
            }
        }
    }
    
    @Override
    Packet createPacket(Source msg) {
        Message message;
        if (msg == null) {
            message = Messages.createEmpty(this.soapVersion);
        }
        else {
            switch (this.mode) {
                case PAYLOAD: {
                    message = new PayloadSourceMessage(null, msg, this.setOutboundAttachments(), this.soapVersion);
                    break;
                }
                case MESSAGE: {
                    message = Messages.create(msg, this.soapVersion);
                    break;
                }
                default: {
                    throw new WebServiceException("Unrecognized message mode");
                }
            }
        }
        return new Packet(message);
    }
}
